// FIXME; IID's are not consistant with SWT version

module dwt.internal.mozilla.nsIDocShell;

import dwt.internal.mozilla.Common;
import dwt.internal.mozilla.nsID;
import dwt.internal.mozilla.nsISupports;

import dwt.internal.mozilla.nsIURI;
import dwt.internal.mozilla.nsIChannel;
import dwt.internal.mozilla.nsIContentViewer;
import dwt.internal.mozilla.nsIURIContentListener;
import dwt.internal.mozilla.nsIChromeEventHandler;
import dwt.internal.mozilla.nsIDocShellLoadInfo;
import dwt.internal.mozilla.nsIDocumentCharsetInfo;
import dwt.internal.mozilla.nsIWebNavigation;
import dwt.internal.mozilla.nsISimpleEnumerator;
import dwt.internal.mozilla.nsIInputStream;
import dwt.internal.mozilla.nsIRequest;
import dwt.internal.mozilla.nsISHEntry;
import dwt.internal.mozilla.nsISecureBrowserUI;
import dwt.internal.mozilla.nsIDOMStorage;
import dwt.internal.mozilla.nsStringAPI;

/******************************************************************************

******************************************************************************/

const char[] NS_IDOCSHELL_IID_STR = "9f0c7461-b9a4-47f6-b88c-421dce1bce66";

const nsIID NS_IDOCSHELL_IID= 
  {0x9f0c7461, 0xb9a4, 0x47f6, 
    [ 0xb8, 0x8c, 0x42, 0x1d, 0xce, 0x1b, 0xce, 0x66 ]};

extern(System)

interface nsIDocShell : nsISupports {

  static const char[] IID_STR = NS_IDOCSHELL_IID_STR;
  static const nsIID IID = NS_IDOCSHELL_IID;

  nsresult LoadURI(nsIURI uri, nsIDocShellLoadInfo loadInfo, PRUint32 aLoadFlags, PRBool firstParty);
  nsresult LoadStream(nsIInputStream aStream, nsIURI aURI, nsACString * aContentType, nsACString * aContentCharset, nsIDocShellLoadInfo aLoadInfo);

  enum { INTERNAL_LOAD_FLAGS_NONE = 0 };
  enum { INTERNAL_LOAD_FLAGS_INHERIT_OWNER = 1 };
  enum { INTERNAL_LOAD_FLAGS_DONT_SEND_REFERRER = 2 };
  enum { INTERNAL_LOAD_FLAGS_ALLOW_THIRD_PARTY_FIXUP = 4 };
  enum { INTERNAL_LOAD_FLAGS_FIRST_LOAD = 8 };

  nsresult InternalLoad(nsIURI aURI, nsIURI aReferrer, nsISupports aOwner, PRUint32 aFlags, PRUnichar *aWindowTarget, char *aTypeHint, nsIInputStream aPostDataStream, nsIInputStream aHeadersStream, PRUint32 aLoadFlags, nsISHEntry aSHEntry, PRBool firstParty, nsIDocShell *aDocShell, nsIRequest *aRequest);

  nsresult CreateLoadInfo(nsIDocShellLoadInfo *loadInfo);
  nsresult PrepareForNewContentModel();
  nsresult SetCurrentURI(nsIURI aURI);
  nsresult FirePageHideNotification(PRBool isUnload);
  nsresult GetPresContext(nsPresContext * *aPresContext);
  nsresult GetPresShell(nsIPresShell * *aPresShell);
  nsresult GetEldestPresShell(nsIPresShell * *aEldestPresShell);
  nsresult GetContentViewer(nsIContentViewer  *aContentViewer);
  nsresult GetChromeEventHandler(nsIChromeEventHandler  *aChromeEventHandler);
  nsresult SetChromeEventHandler(nsIChromeEventHandler  aChromeEventHandler);
  nsresult GetDocumentCharsetInfo(nsIDocumentCharsetInfo  *aDocumentCharsetInfo);
  nsresult SetDocumentCharsetInfo(nsIDocumentCharsetInfo  aDocumentCharsetInfo);
  nsresult GetAllowPlugins(PRBool *aAllowPlugins);
  nsresult SetAllowPlugins(PRBool aAllowPlugins);
  nsresult GetAllowJavascript(PRBool *aAllowJavascript);
  nsresult SetAllowJavascript(PRBool aAllowJavascript);
  nsresult GetAllowMetaRedirects(PRBool *aAllowMetaRedirects);
  nsresult SetAllowMetaRedirects(PRBool aAllowMetaRedirects);
  nsresult GetAllowSubframes(PRBool *aAllowSubframes);
  nsresult SetAllowSubframes(PRBool aAllowSubframes);
  nsresult GetAllowImages(PRBool *aAllowImages);
  nsresult SetAllowImages(PRBool aAllowImages);

  enum { ENUMERATE_FORWARDS = 0 };
  enum { ENUMERATE_BACKWARDS = 1 };

  nsresult GetDocShellEnumerator(PRInt32 aItemType, PRInt32 aDirection, nsISimpleEnumerator *_retval);

  enum { APP_TYPE_UNKNOWN = 0U };
  enum { APP_TYPE_MAIL = 1U };
  enum { APP_TYPE_EDITOR = 2U };

  nsresult GetAppType(PRUint32 *aAppType);
  nsresult SetAppType(PRUint32 aAppType);
  nsresult GetAllowAuth(PRBool *aAllowAuth);
  nsresult SetAllowAuth(PRBool aAllowAuth);
  nsresult GetZoom(float *aZoom);
  nsresult SetZoom(float aZoom);
  nsresult GetMarginWidth(PRInt32 *aMarginWidth);
  nsresult SetMarginWidth(PRInt32 aMarginWidth);
  nsresult GetMarginHeight(PRInt32 *aMarginHeight);
  nsresult SetMarginHeight(PRInt32 aMarginHeight);
  nsresult GetHasFocus(PRBool *aHasFocus);
  nsresult SetHasFocus(PRBool aHasFocus);
  nsresult GetCanvasHasFocus(PRBool *aCanvasHasFocus);
  nsresult SetCanvasHasFocus(PRBool aCanvasHasFocus);
  nsresult TabToTreeOwner(PRBool forward, PRBool *tookFocus);

  enum { BUSY_FLAGS_NONE = 0U };
  enum { BUSY_FLAGS_BUSY = 1U };
  enum { BUSY_FLAGS_BEFORE_PAGE_LOAD = 2U };
  enum { BUSY_FLAGS_PAGE_LOADING = 4U };
  enum { LOAD_CMD_NORMAL = 1U };
  enum { LOAD_CMD_RELOAD = 2U };
  enum { LOAD_CMD_HISTORY = 4U };

  nsresult GetBusyFlags(PRUint32 *aBusyFlags);
  nsresult GetLoadType(PRUint32 *aLoadType);
  nsresult SetLoadType(PRUint32 aLoadType);
  nsresult IsBeingDestroyed(PRBool *_retval);
  nsresult GetIsExecutingOnLoadHandler(PRBool *aIsExecutingOnLoadHandler);
  nsresult GetLayoutHistoryState(nsILayoutHistoryState  *aLayoutHistoryState);
  nsresult SetLayoutHistoryState(nsILayoutHistoryState  aLayoutHistoryState);
  nsresult GetShouldSaveLayoutState(PRBool *aShouldSaveLayoutState);
  nsresult GetSecurityUI(nsISecureBrowserUI  *aSecurityUI);
  nsresult SetSecurityUI(nsISecureBrowserUI  aSecurityUI);
  nsresult SuspendRefreshURIs();
  nsresult ResumeRefreshURIs();
  nsresult BeginRestore(nsIContentViewer viewer, PRBool top);
  nsresult FinishRestore();
  nsresult GetRestoringDocument(PRBool *aRestoringDocument);
  nsresult GetUseErrorPages(PRBool *aUseErrorPages);
  nsresult SetUseErrorPages(PRBool aUseErrorPages);
  nsresult GetPreviousTransIndex(PRInt32 *aPreviousTransIndex);
  nsresult GetLoadedTransIndex(PRInt32 *aLoadedTransIndex);
  nsresult HistoryPurged(PRInt32 numEntries);
}

/******************************************************************************

******************************************************************************/

const char[] NS_IDOCSHELL_MOZILLA_1_8_BRANCH_IID_STR = "45988a14-b240-4d07-ae64-50ecca26e6d8";

const nsIID NS_IDOCSHELL_MOZILLA_1_8_BRANCH_IID= 
  {0x45988a14, 0xb240, 0x4d07, 
    [ 0xae, 0x64, 0x50, 0xec, 0xca, 0x26, 0xe6, 0xd8 ]};

extern(System)

interface nsIDocShell_MOZILLA_1_8_BRANCH : nsISupports {

  static const char[] IID_STR = NS_IDOCSHELL_MOZILLA_1_8_BRANCH_IID_STR;
  static const nsIID IID = NS_IDOCSHELL_MOZILLA_1_8_BRANCH_IID;

  nsresult GetSessionStorageForURI(nsIURI uri, nsIDOMStorage *_retval);
  nsresult AddSessionStorage(nsACString * aDomain, nsIDOMStorage storage);
  nsresult GetCurrentDocumentChannel(nsIChannel  *aCurrentDocumentChannel);
}

/******************************************************************************

******************************************************************************/

const char[] NS_IDOCSHELL_MOZILLA_1_9_BRANCH_IID_STR = "45988a14-b240-4d07-ae64-50ecca26e6d8";

const nsIID NS_IDOCSHELL_MOZILLA_1_9_BRANCH_IID = 
  {0x45988a14, 0xb240, 0x4d07, 
    [ 0xae, 0x64, 0x50, 0xec, 0xca, 0x26, 0xe6, 0xd8 ]};

extern(System)

interface nsIDocShell_MOZILLA_1_9_BRANCH : nsISupports {

  static const char[] IID_STR = NS_IDOCSHELL_MOZILLA_1_9_BRANCH_IID_STR;
  static const nsIID IID = NS_IDOCSHELL_MOZILLA_1_9_BRANCH_IID;

  nsresult GetSessionStorageForURI(nsIURI uri, nsIDOMStorage *_retval);
  nsresult AddSessionStorage(nsACString * aDomain, nsIDOMStorage storage);
  nsresult GetCurrentDocumentChannel(nsIChannel  *aCurrentDocumentChannel);
}